~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/perf/tests/shell/script.sh

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

  1 #!/bin/sh
  2 # perf script tests
  3 # SPDX-License-Identifier: GPL-2.0
  4 
  5 set -e
  6 
  7 temp_dir=$(mktemp -d /tmp/perf-test-script.XXXXXXXXXX)
  8 
  9 perfdatafile="${temp_dir}/perf.data"
 10 db_test="${temp_dir}/db_test.py"
 11 
 12 err=0
 13 
 14 cleanup()
 15 {
 16         trap - EXIT TERM INT
 17         sane=$(echo "${temp_dir}" | cut -b 1-21)
 18         if [ "${sane}" = "/tmp/perf-test-script" ] ; then
 19                 echo "--- Cleaning up ---"
 20                 rm -rf "${temp_dir:?}/"*
 21                 rmdir "${temp_dir}"
 22         fi
 23 }
 24 
 25 trap_cleanup()
 26 {
 27         cleanup
 28         exit 1
 29 }
 30 
 31 trap trap_cleanup EXIT TERM INT
 32 
 33 
 34 test_db()
 35 {
 36         echo "DB test"
 37 
 38         # Check if python script is supported
 39         if perf version --build-options | grep python | grep -q OFF ; then
 40                 echo "SKIP: python scripting is not supported"
 41                 err=2
 42                 return
 43         fi
 44 
 45         cat << "_end_of_file_" > "${db_test}"
 46 perf_db_export_mode = True
 47 perf_db_export_calls = False
 48 perf_db_export_callchains = True
 49 
 50 def sample_table(*args):
 51     print(f'sample_table({args})')
 52 
 53 def call_path_table(*args):
 54     print(f'call_path_table({args}')
 55 _end_of_file_
 56         case $(uname -m)
 57         in s390x)
 58                 cmd_flags="--call-graph dwarf -e cpu-clock";;
 59         *)
 60                 cmd_flags="-g";;
 61         esac
 62 
 63         perf record $cmd_flags -o "${perfdatafile}" true
 64         # Disable lsan to avoid warnings about python memory leaks.
 65         export ASAN_OPTIONS=detect_leaks=0
 66         perf script -i "${perfdatafile}" -s "${db_test}"
 67         export ASAN_OPTIONS=
 68         echo "DB test [Success]"
 69 }
 70 
 71 test_parallel_perf()
 72 {
 73         echo "parallel-perf test"
 74         if ! python3 --version >/dev/null 2>&1 ; then
 75                 echo "SKIP: no python3"
 76                 err=2
 77                 return
 78         fi
 79         pp=$(dirname "$0")/../../scripts/python/parallel-perf.py
 80         if [ ! -f "${pp}" ] ; then
 81                 echo "SKIP: parallel-perf.py script not found "
 82                 err=2
 83                 return
 84         fi
 85         perf_data="${temp_dir}/pp-perf.data"
 86         output1_dir="${temp_dir}/output1"
 87         output2_dir="${temp_dir}/output2"
 88         perf record -o "${perf_data}" --sample-cpu uname
 89         python3 "${pp}" -o "${output1_dir}" --jobs 4 --verbose -- perf script -i "${perf_data}"
 90         python3 "${pp}" -o "${output2_dir}" --jobs 4 --verbose --per-cpu -- perf script -i "${perf_data}"
 91         echo "parallel-perf test [Success]"
 92 }
 93 
 94 test_db
 95 test_parallel_perf
 96 
 97 cleanup
 98 
 99 exit $err

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php